Bug 497940 - iscsid shows iferror -38
iscsid shows iferror -38
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: iscsi-initiator-utils (Show other bugs)
5.3
All Linux
low Severity medium
: rc
: ---
Assigned To: Mike Christie
Red Hat Kernel QE team
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-04-27 21:35 EDT by Wade Mealing
Modified: 2014-09-04 22:59 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
when a user-space iSCSI tool invokes an option that is not supported in the kernel, the tool returns "Iferror -38". Previously, this error message was presented to users and could mislead them to think that a problem existed with their iSCSI configuration. The iSCSI tools no longer present this type of error to users and therefore do not create this potential misunderstanding. Note that certain combinations of new tools with old kernels might still produce a related "-22" error.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 07:31:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Mute the errors , the current upstream version of open-iscsi-2.0.870.3 does it this way. (1.12 KB, patch)
2009-04-27 21:35 EDT, Wade Mealing
no flags Details | Diff

  None (edit)
Description Wade Mealing 2009-04-27 21:35:23 EDT
Created attachment 341497 [details]
Mute the errors , the current upstream version of open-iscsi-2.0.870.3 does it this way.

Description of problem:

Iscsid reports iferror: -38 when attempting to use some parameters that are unsupported.

This trickles down from iscsi_set_param into netlink.c and is not handled correctly.

Version-Release number of selected component (if applicable):

open-iscsi-2.0.868-test1

How reproducible:

Every time


Steps to Reproduce:
1. Setup an iscsi initiator and target
2. Use parameters not handled by the code
3. Profit. (yes, I found step 2)
  
Actual results:

Iferror -38

Expected results:

Its it not implemented, show a better error or show nothing at all.

Additional info:

Patch to be attached.
Comment 4 michal novacek 2009-06-04 11:18:08 EDT
Which is the version of the iscsi-initiator-utils where this does NOT work? I somehow have no idea of how open-iscsi versions translates to iscsi-initiator-utils versions.

Thanks.
Comment 5 Mike Christie 2009-06-04 11:55:30 EDT
This does not work in RHEL 5.3 (iscsi-initiator-utils-6.2.0.868-0.18) and below.

The open-iscsi version is after the iscsi-initiator-utils-6 part of the version. So 2.0.868 is based on upstream http://www.open-iscsi.org/bits/open-iscsi-2.0-868-rc1.tar.gz. The parts after the dash is the RHEL extra version.
Comment 6 michal novacek 2009-06-08 08:22:58 EDT
I just did not have any luck in replicating error "iferror -38 " the issue so
I'm doing something wrong and I would like to ask you for help.

What I do is seting up one node with scsi-target-utils so it shares a volume
and then I have another node which is able to discover and login into the
first one. I have iscsi-initiator-utils-6.2.0.865-0.8.el5 which should be the
one that does this error. 

I tried starting iscsid with wrong parameters and I tried to put some made up
values to /etc/iscsid/iscsid.conf and restart but the above mentioned error
did not occur. How exactly do I make this error occur?

Thanks
Comment 7 Mike Christie 2009-06-08 11:38:22 EDT
It occurs when the kernel does not support a feature/setting that user does. So when the iscsi tools are newer than the kernel. Let me do some digging to check what kernel/tools combos this occurs in. I thought it occured with the stuff in 5.3, but let me check it out real quick.
Comment 8 michal novacek 2009-06-12 13:25:27 EDT
This is repreducible on 5.3, iscsi-initiator-utils-6.2.0.868-0.18.el5 and kernel kernel-2.6.18-128.el5. To see the error, -38/-22 simply log in to the target and check /var/log/messages for "iscsid: received iferror".

I can confirm that the -38 error is gone but the -22 is still there.

Question: should the -22 be gone too?
Comment 9 Mike Christie 2009-06-12 22:41:33 EDT
(In reply to comment #8)
> Question: should the -22 be gone too?  

I would like to keep it.

Older interfaces returned -22 if we tried to set a feature that the kernel did not support. We later changed that to -38 and then used -22 for just when we tried to set a feature or did anything but passed in a invalid param.

So if you use older kernels you could see -22 if you also used newer tools, which is a pain, but I do not think adding lots of complexity to try and detect it is worth it this late.
Comment 10 michal novacek 2009-06-17 06:17:54 EDT
I used /kernel/storage/iscsi-initiator-utils-bz497940-iferror-38 to test this error. 

FAIL -- iscsi-initiator-utils-6.2.0.868-0.18.el5
PASS -- iscsi-initiator-utils-6.2.0.871-0.5.el5
Comment 13 Ruediger Landmann 2009-08-26 08:01:07 EDT
Release note added. If any revisions are required, please set the 
"requires_release_notes" flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

New Contents:
when a user-space iSCSI tool invokes an option that is not supported
in the kernel, the tool returns "Iferror -38". Previously, this error 
message was presented to users and could mislead them to think that
a problem existed with their iSCSI configuration. The iSCSI tools no longer
present this type of error to users and therefore do not create this
potential misunderstanding. Note that certain combinations of new tools
with old kernels might still produce a related "-22" error.
Comment 14 errata-xmlrpc 2009-09-02 07:31:36 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-1368.html

Note You need to log in before you can comment on or make changes to this bug.